/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package jpb_bank;

import java.util.ArrayList;

/**
 *
 * @author eineExSchuelerin
 */
public class Kundenbetreuer extends Mitarbeiter
{
    private double kreditlimit;
    private ArrayList<Kontoinhaber> kontoinhaberListe;
    private double provisionssatz;

    public Kundenbetreuer(double kreditlimit, ArrayList<Kontoinhaber> kontoinhaberListe, double provisionssatz, int mitarbeiternummer, String name, String vorname)
    {
        super(mitarbeiternummer, name, vorname);
        this.kreditlimit = kreditlimit;
        this.kontoinhaberListe = kontoinhaberListe;
        this.provisionssatz = provisionssatz;
    }

    /* HIER ALLE AUFGABEN */
    
    public void listeMeinerBetreutenKundenAlsString() {
    	System.out.println("Name\tVorname\tKtoNr.\tKtoStand");
    	for(Kontoinhaber einK : this.getKontoinhaberListe()) {
    		System.out.print(einK.getName() + "\t");
    		System.out.print(einK.getVorname() + "\t");
    		System.out.print(einK.getGirokonto().getKontonummer() + "\t");
    		System.out.print(einK.getGirokonto().getKontostand() + "\t");
    		System.out.print("\n");
    	}
    }
    public String listeMeinerBetreutenReichenKunden() {    	
    	String rueckgabestring = "";
    	rueckgabestring = rueckgabestring + "Name\tVorname\tKtoNr.\tKtoStand";
    	for(Kontoinhaber einK : this.getKontoinhaberListe()) {
	    		if(einK.getGirokonto().getKontostand() > 500) {
	    		rueckgabestring = rueckgabestring + einK.getName() + "\t";
	    		rueckgabestring = rueckgabestring + einK.getVorname() + "\t";
	    		rueckgabestring = rueckgabestring + einK.getGirokonto().getKontonummer() + "\t";
	    		rueckgabestring = rueckgabestring + einK.getGirokonto().getKontostand() + "\t";
	    		rueckgabestring = rueckgabestring + "\n";
    		}
    	}
    	return rueckgabestring;
    }
    public ArrayList<Kontoinhaber> reichsteKunden() {
    	// Liste erstellen, in die wir die reichsten Kunden packen und die wir dann zurückgeben
      	ArrayList<Kontoinhaber> listeReichsterKunden = new ArrayList<Kontoinhaber>();
    	// erst mal durchschnittlichen Kontostand ermitteln
    	double summe = 0;
    	double durchschnitt = 0;
    	for(Kontoinhaber einK : this.getKontoinhaberListe()) {
    		summe += einK.getGirokonto().getKontostand();
    	}
    	if(this.getKontoinhaberListe().size() == 0) {
    		return listeReichsterKunden; // leere liste, wenn einer keine kunden hat
    	}
    	else {
        	durchschnitt = summe/this.getKontoinhaberListe().size();
        	// waere die liste des Kundenbetreuers leer, würden wir jetzt eine Fehlermeldung erhalten (division by zero)
        	// deshalb packen wir das in eine if-abfrage.
        	// wenn Sie motiviert sind, können sie schon mal surfen, wie man das mit try-catch lösen
        	// würde - machen wir nämlich noch.
    	}

    	// jetzt alle, die über dem durchschnitt liegen, in die liste packen
    	for(Kontoinhaber einK : this.getKontoinhaberListe()) {
    		if(einK.getGirokonto().getKontostand() > durchschnitt) {
    			listeReichsterKunden.add(einK);
    		}
    	}
    	return listeReichsterKunden;
  
    	
    }
    
    public double getKreditlimit()
    {
        return this.kreditlimit;
    }

    public void setKreditlimit(double kreditlimit)
    {
        this.kreditlimit = kreditlimit;
    }

    public ArrayList<Kontoinhaber> getKontoinhaberListe() {
        return kontoinhaberListe;
    }

    public void setKontoinhaberListe(ArrayList<Kontoinhaber> kontoinhaberListe) {
        this.kontoinhaberListe = kontoinhaberListe;
    }

    public double getProvisionssatz()
    {
        return this.provisionssatz;
    }

    public void setProvisionssatz(double provisionssatz)
    {
        this.provisionssatz = provisionssatz;
    }

}
